/**
 * Created by user on 2016/6/27.
 */


define(['angular','commonUtil'], function (angular, commonUtil) {
    angular.module('index',
        [
            'ionic',
            'home.controller',
            'home.services',
            'imgUpload.service',

            'systemManage.module',
            'invoiceManage.module',
            'customerManage.module',
            'commodityManage.module',
            'personCenter.module',
            'enterpriseInfo.module',
            'invoiceClerkManage.module',
            'invoiceSetting.module'


        ])
        .run(['$rootScope', '$location' , '$state', '$timeout', '$ionicPlatform', '$ionicPopup', '$ionicHistory','systemManageService',
          function($rootScope, $location, $state, $timeout, $ionicPlatform, $ionicPopup, $ionicHistory, systemManageService){

            $ionicPlatform.ready(function () {
                if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
                    cordova.plugins.Keyboard.disableScroll(true);
                }
                if (window.StatusBar) {
                    StatusBar.styleDefault();
                }
            });

            //双击退出
            $ionicPlatform.registerBackButtonAction(function (e) {
              //判断处于哪个页面时双击退出
              if ($location.path() == '/tab/home' || $location.path() == '/login') {
                if ($rootScope.backButtonPressedOnceToExit) {
                  ionic.Platform.exitApp();
                } else {
                  $rootScope.backButtonPressedOnceToExit = true;
                  window.plugins.toast.showShortCenter('再按一次退出系统');
                  setTimeout(function () {
                    $rootScope.backButtonPressedOnceToExit = false;
                  }, 2000);
                }
              }
              else if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
              } else {
                $rootScope.backButtonPressedOnceToExit = true;
                window.plugins.toast.showShortCenter('再按一次退出系统');
                setTimeout(function () {
                  $rootScope.backButtonPressedOnceToExit = false;
                }, 2000);
              }
              e.preventDefault();
              return false;
            }, 101);

            //监听路由事件
            $rootScope.$on('$stateChangeStart',
              function(event, toState, toParams, fromState, fromParams){
                if (toState.name !== "registerUser" && toState.name !== "forgetPassword"){
                  systemManageService.checkLogin().then(function (response) {
                    if(!response.data.loginStatus){
                      if(toState.name !== "login"){
                        //提示框
                        var myPopup = commonUtil.popupShow($ionicPopup,"提示", "未登录，请先登录");

                        myPopup.then(function () {
                          $state.go("login", {}, {reload: true});
                        });
                        //自动关闭提示框
                        commonUtil.timeout($timeout, myPopup);
                      }
                    }else{
                      if(response.data.validStatus !== "VALID"){
                        if(toState.name !== "login"){
                          //提示框
                          var myPopup = commonUtil.popupShow($ionicPopup,"提示", "您的账号已被禁用");

                          myPopup.then(function () {
                            $state.go("login", {}, {reload: true});
                          });
                          //自动关闭提示框
                          commonUtil.timeout($timeout, myPopup);
                        }
                      }
                      $rootScope.isAdmin = response.data.clerkType === "ADMIN" ? true : false;
                      $rootScope.reviewOk = response.data.reviewStatus === "REVIEWE_YES" ? true : false;
                      $rootScope.reviewNo = response.data.reviewStatus === "REVIEWE_NO" ? true : false;
                      if(toState.name === "login"){
                        $state.go("tab.home", {}, {reload: true});
                      }
                    }
                  },function (err) {
                    console.log(err);
                  });
                }
              })
        }])


        .config(function ($stateProvider, $urlRouterProvider) {
            $stateProvider
              .state('login', {
                url: '/login',
                cache: false,
                templateUrl: 'templates/system/login.html',
                controller: 'login.controller'
              })
              .state('tab', {
                  url: '/tab',
                  abstract: true,
                  templateUrl: 'templates/common/tabs.html',
                  controller: 'tab.controller'
              })
              .state('tab.home', {
                  url: '/home',
                  cache: true,
                  views: {
                      'tab-home': {
                          templateUrl: 'templates/home/homePage.html',
                          controller: 'home.controller'
                      }
                  }
              })

            $urlRouterProvider.otherwise('/login');
        })
        /**
         * 解决主页底部按钮在android手机出现在顶部情况
         */
        .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {


            $ionicConfigProvider.platform.ios.tabs.style('standard');
            $ionicConfigProvider.platform.ios.tabs.position('bottom');
            $ionicConfigProvider.platform.android.tabs.style('standard');
            $ionicConfigProvider.platform.android.tabs.position('standard');

            $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
            $ionicConfigProvider.platform.android.navBar.alignTitle('left');

            $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
            $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

            $ionicConfigProvider.platform.ios.views.transition('ios');
            $ionicConfigProvider.platform.android.views.transition('android');

        })
});
