/**
 * Created by LJW on 2016/7/23.
 */
define(['angular', 'commonUtil'], function (angular, commonUtil) {
  angular.module('invoiceInsert.controller', [])
    .filter('taxPriceMarkedFilter', function () {
      return function (object) {
        if ('true' === object) {
          return '是';
        }
        if ('false' === object) {
          return '否';
        }
        if ('' === object) {
          return '';
        }
      }
    })
    .filter('discountedFilter', function () {
      return function (object) {
        if ('Y' === object) {
          return '是';
        }
        if ('N' === object) {
          return '否';
        }
        if ('' === object) {
          return '';
        }
      }
    })
    .filter('taxRateFilter', function () {
      return function (object) {
        return object * 100 + '%';
      }
    })
    .filter('proDiscountAmount', function () {
      return function (object) {
        return parseFloat(Math.abs(object)).toFixed(2);
      }
    })
    .controller('invoiceInsert', ['$scope', '$state', '$filter', '$ionicModal', '$ionicHistory', '$timeout', '$ionicLoading', '$ionicPopup', '$location', 'invoiceManageService', 'systemManageService', function ($scope, $state, $filter, $ionicModal, $ionicHistory, $timeout, $ionicLoading, $ionicPopup, $location, invoiceManageService, systemManageService) {
      /*正则常量*/
      var regConstant = {
        negativeFloat: /(^[1-9][0-9]*$)|(^[1-9]\d+(\.)\d{1,2}$)|(^\d(\.)\d{1,2}$)|(^0$)/,
        scaleFloat: /^([1-9]\d?(\.\d{1,2})?|0\.\d{1,2}|0|100)$/  //0-100之间的浮点数
      };
      /*清理页面缓存*/
      $ionicHistory.clearHistory();
      /*获取登录人信息*/
      systemManageService.getLoginInfo().then(function (response) {
        $scope.loginInfo = response.data;
      });
      /*判断是新增发票还是编辑发票*/
      if ('' === $state.params.fpqqlsh) {
        $scope.pageType = 'insert';
        $scope.invoice = {
          gmfMc: '',
          sprMc: '',
          sprSjh: '',
          sprYx: '',
          skr: '',
          proList: [],
          fhr: '',
          bz: ''
        };
        systemManageService.getLoginInfo().then(function (response) {
          $scope.invoice.kpr = response.data.userInfo.clerkName;
          $scope.invoice.xsfDzdh = response.data.enterpriseInfo.xsfDzdh;
          $scope.invoice.xsfKhh = response.data.enterpriseInfo.xsfKhh;
          $scope.invoice.xsfYhzh = response.data.enterpriseInfo.xsfYhzh;
          $scope.invoice.xsfdh = response.data.enterpriseInfo.xsfdh;
        });
      } else {
        $scope.pageType = 'view';
        invoiceManageService.getInvoiceDetail($state.params.fpqqlsh).then(function (response) {
          $scope.invoice = {
            fpqqlsh: $state.params.fpqqlsh,
            bz: response.data.bz,
            fhr: response.data.fhr,
            gmfDzdh: response.data.gmfDzdh,
            gmfKhh: response.data.gmfKhh,
            gmfMc: response.data.gmfMc,
            gmfNsrsbh: response.data.gmfNsrsbh,
            gmfYhzh: response.data.gmfYhzh,
            gmfdh: response.data.gmfdh,
            kpr: response.data.kpr,
            proList: response.data.proList,
            skr: response.data.skr,
            sprMc: response.data.sprMc,
            sprSjh: response.data.sprSjh,
            sprYx: response.data.sprYx,
            xsfDzdh: response.data.xsfDzdh,
            xsfKhh: response.data.xsfKhh,
            xsfYhzh: response.data.xsfYhzh,
            xsfdh: response.data.xsfdh,
            kpzt: response.data.kpzt
          };
        });
      }
      /*新增或编辑或查看发票显示不同title*/
      $scope.titleValue = (('insert' === $scope.pageType || 'update' === $scope.pageType) ? '开票' : '发票详情');
      /*初始化模态页面查询条件*/
      $scope.search = {customerParameter: '', productParameter: '', taxTypeParameter: ''};
      $scope.redirectRedInvoiceInsert = function () {
        if('' !== $scope.invoice.gmfMc || '' !== $scope.invoice.sprMc || '' !== $scope.invoice.sprSjh || '' !== $scope.invoice.sprYx || '' !== $scope.invoice.skr || $scope.invoice.proList.length){
          $ionicPopup.confirm({
            title: '提示',
            template: '确定要离开此页面?',
            cancelText: '取消',
            okText: '确认'
          }).then(function (confirm) {
            if (confirm) {
              $location.path('/redInvoiceInsert');
            }
          });
        }else{
          $location.path('/redInvoiceInsert');
        }
      };
      /*初始化模态页面*/
      oftenCustomerListModal();
      customerListModal();
      addProductModal();
      oftenProductListModal();
      productListModal();
      oftenTaxTypeListModal();
      taxTypeListModal();
      addDiscountModal();
      productDetailModal();
      discountDetailModal();
      /*编辑发票*/
      $scope.editInvoice = function (pageType) {
        $scope.pageType = pageType;
      };
      /*打开常用客户模态页面*/
      $scope.showOftenCustomerListModal = showOftenCustomerListModal;
      /*关闭常用客户模态页面*/
      $scope.hideOftenCustomerListModal = function () {
        $scope.oftenCustomerListModal.hide();
      };
      /*选择常用客户*/
      $scope.selectOftenCustomer = function (oftenCustomer) {
        $scope.oftenCustomerListModal.hide();
        setInvoiceProperty(oftenCustomer);
      };
      /*打开客户模态页面*/
      $scope.showCustomerListModal = function () {
        invoiceManageService.getCustomerList(0, 100, $scope.search.customerParameter).then(function (response) {
          $scope.customerList = response.data.page;
        });
        $scope.oftenCustomerListModal.hide();
        $scope.customerListModal.show();
      };
      /*关闭客户模态页面*/
      $scope.hideCustomerListModal = function () {
        $scope.customerListModal.hide();
        showOftenCustomerListModal();
      };
      /*选择客户*/
      $scope.selectCustomer = function (customer) {
        $scope.customerListModal.hide();
        setInvoiceProperty(customer);
      };
      /*打开增加商品行模态页*/
      $scope.showAddProductModal = function () {
        $scope.insertProduct = true;
        $scope.productInfo = {
          productId: '',
          hsbz: '1'
        };
        showAddProductModal();
      };
      /*隐藏增加商品行模态页*/
      $scope.hideAddProductModal = function () {
        $scope.addProductModal.hide();
      };
      /*打开编辑产品模态页*/
      $scope.showEditProductModal = function (pro) {
        $scope.insertProduct = false;
        $scope.productInfo = pro;
        showAddProductModal();
      };
      /*删除产品*/
      $scope.removeProduct = function (index) {
        $scope.invoice.proList.splice(index, 1);
      };
      /*打开产品详情模态页*/
      $scope.showProductDetailModal = function (product) {
        $scope.productDatail = product;
        $scope.productDetailModal.show();
      };
      /*隐藏产品详情模态页*/
      $scope.hideProductDetailModal = function () {
        $scope.productDatail = {};
        $scope.productDetailModal.hide();
      };
      /*打开常用商品模态页*/
      $scope.showOftenProductListModal = showOftenProductListModal;
      /*隐藏常用商品模态页*/
      $scope.hideOftenProductListModal = function () {
        $scope.oftenProductListModal.hide();
      };
      /*选择常用商品*/
      $scope.selectOftenProduct = function (oftenProduct) {
        $scope.oftenProductListModal.hide();
        setProductProperty(oftenProduct);
      };
      /*打开商品模态页*/
      $scope.showProductListModal = function () {
        invoiceManageService.getProductList(0, 100, $scope.search.productParameter).then(function (response) {
          $scope.productList = response.data.page;
        });
        $scope.oftenProductListModal.hide();
        $scope.productListModal.show();
      };
      /*隐藏商品模态页*/
      $scope.hideProductListModal = function () {
        $scope.productListModal.hide();
        showOftenProductListModal();
      };
      /*选择商品*/
      $scope.selectProduct = function (product) {
        $scope.productListModal.hide();
        setProductProperty(product);
      };
      /*保存商品*/
      $scope.saveProduct = function () {
        if ($scope.insertProduct) {
          $scope.invoice.proList.push($scope.productInfo);
        }
        $scope.addProductModal.hide();
      };
      /*打开常用税收分类模态页*/
      $scope.showOftenTaxTypeListModal = showOftenTaxTypeListModal;
      /*关闭常用税收分类模态页*/
      $scope.hideOftenTaxTypeListModal = function () {
        $scope.oftenTaxTypeListModal.hide();
      };
      /*选择常用税收分类*/
      $scope.selectOftenTaxType = function (oftenTaxType) {
        $scope.oftenTaxTypeListModal.hide();
        $scope.productInfo.taxClassificationCode = oftenTaxType.mergeCoding;
        $scope.productInfo.taxClassificationName = oftenTaxType.goodsName;
      };
      /*打开税收分类模态页*/
      $scope.showTaxTypeListModal = function () {
        invoiceManageService.getTaxTypeList(0, 100, $scope.search.taxTypeParameter).then(function (response) {
          $scope.taxTypeList = response.data.page;
        });
        $scope.oftenTaxTypeListModal.hide();
        $scope.taxTypeListModal.show();
      };
      /*关闭税收分类模态页*/
      $scope.hideTaxTypeListModal = function () {
        $scope.taxTypeListModal.hide();
        showOftenTaxTypeListModal();
      };
      /*选择税收分类*/
      $scope.selectTaxType = function (taxType) {
        $scope.taxTypeListModal.hide();
        $scope.productInfo.taxClassificationCode = taxType.mergeCoding;
        $scope.productInfo.taxClassificationName = taxType.goodsName;
      };
      /*打开折扣行模态页*/
      $scope.showAddDiscountModal = function (index, product) {
        $scope.productIndex = index;
        $scope.discount = {
          productInfo: product
        };
        $scope.discount.disabledButton = true;
        showAddDiscountModal();
      };
      /*隐藏折扣行模态页*/
      $scope.hideAddDiscountModal = function () {
        $scope.discount = {};
        $scope.addDiscountModal.hide();
      };
      /*保存折扣行信息*/
      $scope.saveDiscount = function () {
        if (undefined !== $scope.discount.discountRate) {
          $scope.invoice.proList[$scope.productIndex].discountTaxRate = $scope.discount.discountRate;
          $scope.invoice.proList[$scope.productIndex].discountAmount = $scope.discount.amount;
          $scope.invoice.proList[$scope.productIndex].discountTaxAmount = parseFloat($scope.discount.amount * $scope.discount.productInfo.taxRate).toFixed(2);
        }
        $scope.discount = {};
        $scope.addDiscountModal.hide();
      };
      /*编辑折扣行信息*/
      $scope.showEditDiscountModal = function (product) {
        $scope.discount = {
          productInfo: product,
          discountRate: product.discountTaxRate,
          amount: Math.abs(product.discountAmount)
        };
        $scope.discount.disabledButton = false;
        showAddDiscountModal();
      };
      /*删除折扣行信息*/
      $scope.removeDiscount = function (index) {
        delete $scope.invoice.proList[index].discountTaxRate;
        delete $scope.invoice.proList[index].discountAmount;
        delete $scope.invoice.proList[index].discountTaxAmount;
      };
      /*打开折扣详情模态页*/
      $scope.showDiscountDetailModal = function (product) {
        $scope.discountDatail = {
          goodsServiceName: product.goodsServiceName,
          amount: product.amount,
          taxRate: product.taxRate,
          discountTaxRate: product.discountTaxRate,
          discountTaxAmount: Math.abs(product.discountAmount)
        };
        $scope.discountDetailModal.show();
      };
      /*关闭折扣详情模态页*/
      $scope.hideDiscountDetailModal = function () {
        $scope.discountDatail = {};
        $scope.discountDetailModal.hide();
      };
      /*发票合计金额*/
      $scope.totalAmount = function () {
        var totalAmount = 0;
        angular.forEach($scope.invoice.proList, function (item) {
          if('1' === item.hsbz){
            if ('discountTaxRate' in item) {
              totalAmount += (item.amount / (1 + item.taxRate * 1) - (item.amount / (1 + item.taxRate * 1)) * item.discountTaxRate / 100);
            } else {
              totalAmount += item.amount / (1 + item.taxRate * 1) * 1;
            }
          }else{
            if ('discountTaxRate' in item) {
              totalAmount += (item.amount * 1 - item.amount * item.discountTaxRate / 100);
            } else {
              totalAmount += item.amount * 1;
            }
          }
        });
        return totalAmount;
      };
      /*发票合计税额*/
      $scope.totalTax = function () {
        var totalTax = 0;
        angular.forEach($scope.invoice.proList, function (item) {
          if('1' === item.hsbz){
            if ('discountTaxRate' in item) {
              totalTax += (item.amount / (1 + item.taxRate * 1) * item.taxRate - (item.amount / (1 + item.taxRate * 1) * item.discountTaxRate / 100 * item.taxRate));
            } else {
              totalTax += item.amount / (1 + item.taxRate * 1) * item.taxRate;
            }
          }else{
            if ('discountTaxRate' in item) {
              totalTax += (item.amount * item.taxRate - (item.amount * item.discountTaxRate / 100 * item.taxRate));
            } else {
              totalTax += item.amount * item.taxRate;
            }
          }
        });
        return totalTax;
      };
      /*保存发票*/
      $scope.saveInvoice = function (formObject) {
        commonUtil.loadingShow($ionicLoading);
        invoiceManageService.saveInvoice($scope.invoice).then(function (response) {
          $ionicLoading.hide();
          var popup = commonUtil.popupShow($ionicPopup, "提示", '200' === response.code ? '保存成功' : '失败失败');
          popup.then(function () {
            if ('200' === response.code) {
              $scope.invoice = {
                kpr: $scope.loginInfo.userInfo.clerkName,
                xsfDzdh: $scope.loginInfo.enterpriseInfo.xsfDzdh,
                xsfKhh: $scope.loginInfo.enterpriseInfo.xsfKhh,
                xsfYhzh: $scope.loginInfo.enterpriseInfo.xsfYhzh,
                xsfdh: $scope.loginInfo.enterpriseInfo.xsfdh,
                proList: [],
                fhr: '',
                bz: ''
              };
              formObject.$setPristine();
            }
          });
          commonUtil.timeout($timeout, popup);
        });
      };
      /*保存并开具发票*/
      $scope.saveAndMakeInvoice = function (formObject) {
        commonUtil.loadingShow($ionicLoading);
        invoiceManageService.saveAndMakeInvoice($scope.invoice).then(function (response) {
          $ionicLoading.hide();
          var popup = commonUtil.popupShow($ionicPopup, "提示", '200' === response.code ? '请求成功，系统将自动为您开票' : '请求失败');
          popup.then(function () {
            if ('200' === response.code) {
              $scope.invoice = {
                kpr: $scope.loginInfo.userInfo.clerkName,
                xsfDzdh: $scope.loginInfo.enterpriseInfo.xsfDzdh,
                xsfKhh: $scope.loginInfo.enterpriseInfo.xsfKhh,
                xsfYhzh: $scope.loginInfo.enterpriseInfo.xsfYhzh,
                xsfdh: $scope.loginInfo.enterpriseInfo.xsfdh,
                proList: [],
                fhr: '',
                bz: ''
              };
              formObject.$setPristine();
            }
          });
          commonUtil.timeout($timeout, popup);
        });
      };
      /*修改发票信息*/
      $scope.updateInvoice = function () {
        commonUtil.loadingShow($ionicLoading);
        invoiceManageService.updateInvoice($scope.invoice).then(function (response) {
          $ionicLoading.hide();
          var popup = commonUtil.popupShow($ionicPopup, "提示", '200' === response.code ? '保存成功' : '保存失败');
          popup.then(function () {
            if ('200' === response.code) {
              $location.path('/tab/invoiceList');
            }
          });
          commonUtil.timeout($timeout, popup);
        });
      };
      /*设置发票属性*/
      function setInvoiceProperty(object) {
        $scope.invoice.gmfMc = object.customerName;
        $scope.invoice.gmfdh = object.enterprisePhone;
        $scope.invoice.gmfDzdh = object.address;
        $scope.invoice.gmfNsrsbh = object.customerTaxNum;
        $scope.invoice.gmfKhh = object.bankAccount;
        $scope.invoice.gmfYhzh = object.accountNum;
        $scope.invoice.sprMc = object.contactName;
        $scope.invoice.sprSjh = object.contactPhone;
        $scope.invoice.sprYx = object.contactEmail;
      };
      /*设置商品属性*/
      function setProductProperty(object) {
        $scope.productInfo.productId = object.enterpriseProductId
        $scope.productInfo.goodsServiceName = object.productName;
        //判断是否是试点地区
        if (true === $scope.loginInfo.areaFlag) {
          $scope.productInfo.taxClassificationCode = object.taxClassificationCode;
          $scope.productInfo.taxClassificationName = object.taxClassificationName;
        } else {
          $scope.productInfo.taxClassificationCode = '';
          $scope.productInfo.taxClassificationName = '';
        }
        $scope.productInfo.specificationModel = object.specificationModel;
        $scope.productInfo.meteringUnit = object.meteringUnit;
        $scope.productInfo.price = parseFloat(object.price).toFixed(2);
        //判断商品是否含税
        if ('true' === object.taxPriceMarked) {
          $scope.productInfo.hsbz = '1';
        } else {
          $scope.productInfo.hsbz = '0';
        }
        angular.forEach($scope.taxRateList, function (value) {
          if(value.taxRateValue === object.taxRateValue){
            $scope.productInfo.taxRate = object.taxRateValue;
          }
        });
      };
      function showAddProductModal() {
        if(undefined === $scope.productInfo.quantity){
          $scope.changeQuantityFlag = true;
        }else{
          $scope.changeQuantityFlag = false;
        }
        $scope.$watch('productInfo.quantity', function (value) {
          if(undefined === value || ''=== value){
            $scope.changeQuantityFlag = true;
          }
        });
        $scope.addProductModalFunction = {
          addQuantity: function () {
            if (undefined === $scope.productInfo.quantity) {
              $scope.productInfo.quantity = 0;
            }
            ++$scope.productInfo.quantity;
            $scope.addProductModalFunction.quantityChange();
          },
          reduceQuantity: function () {
            if (0 < $scope.productInfo.quantity) {
              --$scope.productInfo.quantity;
            }
            if(0 === $scope.productInfo.quantity){
              delete $scope.productInfo.quantity;
              delete $scope.productInfo.price;
              delete $scope.productInfo.amount;
            }
            $scope.addProductModalFunction.quantityChange();
          },
          quantityBlur: function () {
            if (!regConstant.negativeFloat.test($scope.productInfo.quantity)) {
              delete $scope.productInfo.quantity;
            }
          },
          quantityChange: function () {
            $scope.changeQuantityFlag = false;
            if(regConstant.negativeFloat.test($scope.productInfo.quantity) && (regConstant.negativeFloat.test($scope.productInfo.price) || regConstant.negativeFloat.test($scope.productInfo.amount))){
              if (undefined === $scope.productInfo.price) {
                $scope.productInfo.price = parseFloat($scope.productInfo.amount / $scope.productInfo.quantity).toFixed(2);
              } else {
                $scope.productInfo.amount = parseFloat($scope.productInfo.quantity * $scope.productInfo.price).toFixed(2);
              }
            }
            if(0 === $scope.productInfo.quantity || undefined === $scope.productInfo.quantity){
              delete $scope.productInfo.quantity;
              delete $scope.productInfo.price;
              delete $scope.productInfo.amount;
            }
          },
          priceBlur: function () {
            if(!regConstant.negativeFloat.test($scope.productInfo.price)){
              delete $scope.productInfo.price;
            }
          },
          priceChange: function () {
            if(regConstant.negativeFloat.test($scope.productInfo.price) && (regConstant.negativeFloat.test($scope.productInfo.quantity) || regConstant.negativeFloat.test($scope.productInfo.amount))){
              if (undefined === $scope.productInfo.quantity) {
                $scope.productInfo.quantity = parseFloat($scope.productInfo.amount / $scope.productInfo.price).toFixed(2);
              } else {
                $scope.productInfo.amount = parseFloat($scope.productInfo.quantity * $scope.productInfo.price).toFixed(2);
              }
            }
          },
          amountBlur: function () {
            $scope.changeQuantityFlag = false;
            if (!regConstant.negativeFloat.test($scope.productInfo.amount)) {
              delete $scope.productInfo.amount;
            }
          },
          amountChange: function () {
            if(regConstant.negativeFloat.test($scope.productInfo.amount) && (regConstant.negativeFloat.test($scope.productInfo.quantity) || regConstant.negativeFloat.test($scope.productInfo.price))){
              if($scope.changeQuantityFlag){
                if(regConstant.negativeFloat.test($scope.productInfo.quantity) && !regConstant.negativeFloat.test($scope.productInfo.price)){
                  $scope.productInfo.price = parseFloat($scope.productInfo.amount / $scope.productInfo.quantity).toFixed(2);
                }
                if(regConstant.negativeFloat.test($scope.productInfo.price)){
                  $scope.productInfo.quantity = parseFloat($scope.productInfo.amount / $scope.productInfo.price).toFixed(2);
                }
              }
              if(!$scope.changeQuantityFlag && regConstant.negativeFloat.test($scope.productInfo.quantity)){
                $scope.productInfo.price = parseFloat($scope.productInfo.amount / $scope.productInfo.quantity).toFixed(2);
              }
            }
          },
          hsbzChange: function () {
            if (undefined !== $scope.productInfo.quantity && undefined !== $scope.productInfo.price && undefined !== $scope.productInfo.amount && undefined !== $scope.productInfo.taxRate) {
              if ('1' === $scope.productInfo.hsbz) {
                $scope.productInfo.price = parseFloat($scope.productInfo.price * 1 + $scope.productInfo.price * $scope.productInfo.taxRate).toFixed(2);
                $scope.productInfo.amount = parseFloat($scope.productInfo.price * $scope.productInfo.quantity).toFixed(2);
              } else {
                $scope.productInfo.price = parseFloat($scope.productInfo.price / (1 + $scope.productInfo.taxRate * 1)).toFixed(2);
                $scope.productInfo.amount = parseFloat($scope.productInfo.price * $scope.productInfo.quantity).toFixed(2);
              }
            } else {
              delete $scope.productInfo.price;
              delete $scope.productInfo.amount;
            }
          }
        };
        invoiceManageService.getEnterpriseTaxRateList().then(function (response) {
          $scope.taxRateList = response.data;
        });
        $scope.addProductModal.show();
      };

      function showAddDiscountModal() {
        $scope.addDiscountModalFunction = {
          amountBlur: function () {
            if (!regConstant.negativeFloat.test($scope.discount.amount) || ($scope.discount.amount * 1 > $scope.discount.productInfo.amount * 1)) {
              delete $scope.discount.amount;
            }
          },
          discountRateBlur: function () {
            if (!regConstant.scaleFloat.test($scope.discount.discountRate)) {
              delete $scope.discount.discountRate;
            }
          },
          amountChange: function () {
            if (regConstant.negativeFloat.test($scope.discount.amount) && ($scope.discount.amount * 1 <= $scope.discount.productInfo.amount * 1)) {
              $scope.discount.discountRate = parseFloat($scope.discount.amount / $scope.discount.productInfo.amount  * 100).toFixed(2);
              $scope.discount.disabledButton = false;
            }
            if (!regConstant.negativeFloat.test($scope.discount.amount) || ($scope.discount.amount * 1 > $scope.discount.productInfo.amount * 1)) {
              $scope.discount.disabledButton = true;
            }
          },
          discountRateChange: function () {
            if (regConstant.scaleFloat.test($scope.discount.discountRate)) {
              $scope.discount.amount = parseFloat($scope.discount.productInfo.amount * $scope.discount.discountRate / 100).toFixed(2);
              $scope.discount.disabledButton = false;
            }else{
              $scope.discount.disabledButton = true;
            }
          }
        };
        $scope.addDiscountModal.show();
      }

      function showOftenCustomerListModal() {
        $scope.oftenCustomerList = [];
        /*暂时注销*/
        // invoiceManageService.getOftenCustomerList().then(function (response) {
        //   $scope.oftenCustomerList = response.data;
        // });
        $scope.oftenCustomerListModal.show();
      }

      function showOftenProductListModal() {
        $scope.oftenProductList = [];
        /*暂时注销*/
        // invoiceManageService.getOftenProductList().then(function (response) {
        //   $scope.oftenProductList = response.data;
        // });
        $scope.oftenProductListModal.show();
      }

      function showOftenTaxTypeListModal() {
        invoiceManageService.getOftenTaxTypeList(0, 20).then(function (response) {
          $scope.oftenTaxTypeList = response.data.page;
        });
        $scope.oftenTaxTypeListModal.show();
      }

      function oftenCustomerListModal() {
        $ionicModal.fromTemplateUrl("oftenCustomerList-modal.html", {
          scope: $scope,
          animation: "slide-in-up"
        }).then(function (modal) {
          $scope.oftenCustomerListModal = modal;
        });
      }

      function customerListModal() {
        $ionicModal.fromTemplateUrl("customerList-modal.html", {
          scope: $scope,
          animation: "slide-in-up"
        }).then(function (modal) {
          $scope.customerListModal = modal;
        });
      }

      function addProductModal() {
        $ionicModal.fromTemplateUrl("addProduct-modal.html", {
          scope: $scope,
          animation: "slide-in-up"
        }).then(function (modal) {
          $scope.addProductModal = modal;
        });
      }

      function oftenProductListModal() {
        $ionicModal.fromTemplateUrl("oftenProductList-modal.html", {
          scope: $scope,
          animation: "slide-in-up"
        }).then(function (modal) {
          $scope.oftenProductListModal = modal;
        });
      }

      function productListModal() {
        $ionicModal.fromTemplateUrl("productList-modal.html", {
          scope: $scope,
          animation: "slide-in-up"
        }).then(function (modal) {
          $scope.productListModal = modal;
        });
      }

      function oftenTaxTypeListModal() {
        $ionicModal.fromTemplateUrl("oftenTaxTypeList-modal.html", {
          scope: $scope,
          animation: "slide-in-up"
        }).then(function (modal) {
          $scope.oftenTaxTypeListModal = modal;
        });
      }

      function taxTypeListModal() {
        $ionicModal.fromTemplateUrl("taxTypeList-modal.html", {
          scope: $scope,
          animation: "slide-in-up"
        }).then(function (modal) {
          $scope.taxTypeListModal = modal;
        });
      }

      function addDiscountModal() {
        $ionicModal.fromTemplateUrl("addDiscount-modal.html", {
          scope: $scope,
          animation: "slide-in-up"
        }).then(function (modal) {
          $scope.addDiscountModal = modal;
        });
      }

      function productDetailModal() {
        $ionicModal.fromTemplateUrl("productDetail-modal.html", {
          scope: $scope,
          animation: "slide-in-up"
        }).then(function (modal) {
          $scope.productDetailModal = modal;
        });
      }

      function discountDetailModal() {
        $ionicModal.fromTemplateUrl("discountDetail-modal.html", {
          scope: $scope,
          animation: "slide-in-up"
        }).then(function (modal) {
          $scope.discountDetailModal = modal;
        });
      }
    }]);
});
