define(['angular','commonUtil','validUtil'], function (angular,commonUtil,validUtil) {

  angular.module('personCenter.controller',[])

    .controller('personList.controller', ['$scope', '$state', '$ionicPopup', '$location', 'personCenterService', 'systemManageService',
      function($scope, $state, $ionicPopup, $location, personCenterService, systemManageService){

        $scope.$on('$ionicView.beforeEnter',function(){
          getPersonCenter($scope, personCenterService);
        });

        $scope.logout = function () {
          $ionicPopup.confirm({
            title: '退出登录',
            template: '确定要退出当前账号?',
            cancelText: '取消',
            okText: '确认'
          }).then(function (confirm) {
            if (confirm) {
              window.localStorage.removeItem('loginInfo');
              systemManageService.logout().then(function (response) {
                if(200 === response.code){
                  $location.path('/login');
                }
              });
            }
          });
        };
      }])
    .controller('eidtPersonMsg.controller', ['$scope','$state','$ionicPopup','$ionicLoading','$timeout','personCenterService',
      function($scope,$state,$ionicPopup,$ionicLoading,$timeout,personCenterService){

        $scope.ifShowPasswordModfiy = false;

        $scope.ifLoginPwdInvalid = false;
        $scope.ifNewPwdInvalid = false;
        $scope.ifNewConfirmPwdInvalid = false;
        $scope.ifEqualNewPwd = false;

        $scope.notValidPhone = false;

        getPersonCenter($scope, personCenterService);

        $scope.savePersonMsg = function() {
          //loading提示框，防止重复提交
          commonUtil.loadingShow($ionicLoading);

          var params = $scope.clerk;
          personCenterService.editPersonMsg(params).then(function (response) {
            //对应loadingShow，关闭loading
            $ionicLoading.hide();
            //提示框
            var myPopup = commonUtil.popupShow($ionicPopup,"提示", '200' === response.code ? '保存成功' : '保存失败');

            if(response.code === "200"){
              myPopup.then(function () {
                $state.go("tab.personCenterController", {}, {reload: true});
              });
            }else{
              $scope.clerk.loginPassword = "";
              $scope.clerk.passwordNew = "";
              $scope.clerk.passwordNewConfirm = "";
            }

            //自动关闭提示框
            commonUtil.timeout($timeout, myPopup);
          });
        };

        $scope.changePasswordModify = function(){
          $scope.ifShowPasswordModfiy = !($scope.ifShowPasswordModfiy);
        }

        $scope.validPhone = function(){
          if(!validUtil.phoneValid($scope.clerk.contractPhone)){
            $scope.notValidPhone = true;
          }else{
            $scope.notValidPhone = false;
          }
        }
        $scope.validPassword = function(){
          var originPwd = $scope.clerk.loginPassword;
          var newPwd = $scope.clerk.passwordNew;
          var pwdConfirm = $scope.clerk.passwordNewConfirm;
          if(typeof(newPwd) == "undefined"){
            newPwd = "";
          }
          if(typeof(pwdConfirm) == "undefined"){
            pwdConfirm = "";
          }

          if(originPwd !== "" && !validUtil.passwordValid(originPwd)){
            $scope.ifLoginPwdInvalid = true;
            $scope.ifNewPwdInvalid = false;
            $scope.ifNewConfirmPwdInvalid = false;
            $scope.ifEqualNewPwd = false;
          }else if(newPwd !== "" && !validUtil.passwordValid(newPwd)){
            $scope.ifLoginPwdInvalid = false;
            $scope.ifNewPwdInvalid = true;
            $scope.ifNewConfirmPwdInvalid = false;
            $scope.ifEqualNewPwd = false;
          }else if(pwdConfirm !== "" && !validUtil.passwordValid(pwdConfirm)){
            $scope.ifLoginPwdInvalid = false;
            $scope.ifNewPwdInvalid = false;
            $scope.ifNewConfirmPwdInvalid = true;
            $scope.ifEqualNewPwd = false;
          }else if(newPwd !== pwdConfirm){
            $scope.ifLoginPwdInvalid = false;
            $scope.ifNewPwdInvalid = false;
            $scope.ifNewConfirmPwdInvalid = false;
            $scope.ifEqualNewPwd = true;
          }else if(originPwd === "" && newPwd !== "" && pwdConfirm !== ""){
            $scope.ifLoginPwdInvalid = true;
            $scope.ifNewPwdInvalid = false;
            $scope.ifNewConfirmPwdInvalid = false;
            $scope.ifEqualNewPwd = false;
          }else{
            $scope.ifLoginPwdInvalid = false;
            $scope.ifNewPwdInvalid = false;
            $scope.ifNewConfirmPwdInvalid = false;
            $scope.ifEqualNewPwd = false;
          }

        }

      }])

  function getPersonCenter($scope, personCenterService){
    $scope.today = new Date();
    personCenterService.getPersonCenterList().then(function (response) {
      $scope.clerk = response.data;
    });
  }

});
