/**
 * Created by LJW on 2016/7/23.
 */
define(['angular', 'commonUtil'], function (angular, commonUtil) {
  angular.module('redInvoiceInsert.controller', [])
    .controller('redInvoiceInsert', ['$scope', '$ionicModal', '$ionicLoading', '$ionicPopup', '$timeout', '$filter', 'invoiceManageService', function ($scope, $ionicModal, $ionicLoading, $ionicPopup, $timeout, $filter, invoiceManageService) {
      redInvoiceInsertModal();
      $scope.redInvoice = {};
      $scope.next = function (formObject) {
        invoiceManageService.validateInvoice($scope.redInvoice.code + '_' + $scope.redInvoice.number).then(function (response) {
          if ('200' === response.code) {
            formObject.$setPristine();
            $scope.redInvoiceInsertModal.show();
            invoiceManageService.getRedInvoiceDeatil($scope.redInvoice.code + '_' + $scope.redInvoice.number).then(function (response) {
              $scope.redInvoiceDetail = {
                gmfMc: response.data.gmfMc,
                hjje: response.data.hjje,
                hjse: response.data.hjse,
                jshj: response.data.jshj,
                skr: response.data.skr,
                proList: response.data.proList,
                proList: response.data.proList
              };
            }, function (err) {
              console.log(err);
            });
          } else {
            var popup = commonUtil.popupShow($ionicPopup, "提示", '校验失败');
            commonUtil.timeout($timeout, popup);
          }
        });
      };
      $scope.hideRedInvoiceInsertModal = function () {
        $scope.redInvoiceInsertModal.hide();
      };
      $scope.saveRedInvoice = function () {
        commonUtil.loadingShow($ionicLoading);
        invoiceManageService.saveRedInvoice($scope.redInvoice.code + '_' + $scope.redInvoice.number, $scope.redInvoice.redReason).then(function (response) {
          $ionicLoading.hide();
          var popup = commonUtil.popupShow($ionicPopup, "提示", '200' === response.code ? '保存成功' : '保存失败');
          popup.then(function () {
            if ('200' === response.code) {
              $scope.redInvoice = {};
              $scope.redInvoiceDetail = {};
              $scope.redInvoiceInsertModal.hide();
            }
          });
          commonUtil.timeout($timeout, popup);
        });
      };
      function redInvoiceInsertModal() {
        $ionicModal.fromTemplateUrl("redInvoiceInsert-modal.html", {
          scope: $scope,
          animation: "slide-in-up"
        }).then(function (modal) {
          $scope.redInvoiceInsertModal = modal;
        });
      }
    }]);
});
