define(['angular', 'validUtil', 'commonUtil', 'rsa', 'jsbn', 'prng4', 'rng', 'ajax_factory'], function (angular, validUtil, commonUtil, rsa, jsbn, prng4, rng, ajax_factory) {

  angular.module('systemManage.controller', [])
    .directive('timerButtons', ['$timeout', '$interval', '$filter', 'systemManageService', function ($timeout, $interval, $filter, systemManageService) {
      return {
        restrict: 'AE',
        $scope: {
          showTimer: '',
          timeout: ''
        },
        link: function ($scope) {
          $scope.disabledButton = false;
          $scope.timeout = 60000;
          $scope.timerCount = $scope.timeout / 1000;
          $scope.text = "获取验证码";
          $scope.sendVerificationCode = function () {
            if(validUtil.phoneValid($scope.enterInfo.contactsPhone)){
              $scope.showTimer = true;
              $scope.disabledButton = true;
              $scope.text = "秒后重新获取";
              var counter = $interval(function () {
                $scope.timerCount = $scope.timerCount - 1;
              }, 1000);
              $timeout(function () {
                $scope.text = "获取验证码";
                $scope.disabledButton = false;
                $interval.cancel(counter);
                $scope.showTimer = false;
                $scope.timerCount = $scope.timeout / 1000;
              }, $scope.timeout);
              systemManageService.sendVerificationCode($scope.enterInfo.contactsPhone);
            }
          }
        },
        template: '<a on-tap="sendVerificationCode();" class="button button-block pt-public-btn1 yzm-font" ng-disabled="disabledButton"><div style="text-align: center"><span ng-if="showTimer">{{timerCount}}</span>{{text}}</div></a>'
      };
    }])

    .controller('registerUser.controller', ['$scope', '$state', '$ionicModal', '$ionicPopup', '$ionicLoading', '$timeout', '$filter','systemManageService','enterpriseInfoService', 'imgUploadService',
      function ($scope, $state, $ionicModal, $ionicPopup, $ionicLoading, $timeout,$filter,systemManageService, enterpriseInfoService, imgUploadService) {
        $scope.notValidPhone = false;
        $scope.notValidTaxpayerNum = false;
        $scope.notValidEnterpriseName = false;
        $scope.notValidContactsName = false;
        $scope.notValidLegalRepresentativeName = false;
        $scope.notValidEmail = false;
        $scope.notValidCaptcha = false;

        $scope.enterInfo = new Object();
        $scope.pushNotification = {checked: false};

        var downloadUrl = ajax_factory.getPath("download");
        $scope.imgSrc = "";
        $scope.displayImg = false;

        $scope.enterpriseAddressTemp = "";
        $scope.changeCaptcha = function () {
          $scope.notValidCaptcha = false;
        };
        $scope.validPhone = function () {
          if (!validUtil.phoneValid($scope.enterInfo.contactsPhone)) {
            $scope.notValidPhone = true;
          } else {
            $scope.notValidPhone = false;
          }
        }

        $scope.validCharNum = function () {
          if (!validUtil.charNumValid($scope.enterInfo.taxpayerNum)) {
            $scope.notValidTaxpayerNum = true;
          } else {
            $scope.notValidTaxpayerNum = false;
          }
        }

        $scope.validEnterpriseName = function () {
          if (!validUtil.nameValid($scope.enterInfo.enterpriseName)) {
            $scope.notValidEnterpriseName = true;
          } else {
            $scope.notValidEnterpriseName = false;
          }
        }

        $scope.validContactsName = function () {
          if (!validUtil.nameValid($scope.enterInfo.contactsName)) {
            $scope.notValidContactsName = true;
          } else {
            $scope.notValidContactsName = false;
          }
        }

        $scope.checkServiceAgreement = function () {
          $scope.pushNotification.checked;
        }

        $scope.validPassword = function () {
          if (!validUtil.passwordValid($scope.enterInfo.password)) {
            $scope.notValidPassword = true;
          } else {
            $scope.notValidPassword = false;
          }
        }

        $scope.validConfirmPassword = function () {
          var loginPwd = $scope.enterInfo.password;
          var confirmPwd = $scope.enterInfo.passwordNewConfirm;
          if (confirmPwd !== loginPwd) {
            $scope.ifEqualNewPwd = true;
          } else {
            $scope.ifEqualNewPwd = false;
          }
        }

        $scope.validEmail = function () {
          if (!validUtil.emailValid($scope.enterInfo.contactsEmail)) {
            $scope.notValidEmail = true;
          } else {
            $scope.notValidEmail = false;
          }
        }

        $scope.validLegalRepresentativeName = function () {
          if (!validUtil.nameValid($scope.enterInfo.legalRepresentativeName)) {
            $scope.notValidLegalRepresentativeName = true;
          } else {
            $scope.notValidLegalRepresentativeName = false;
          }
        }

        $scope.validEmail = function () {
          if (!validUtil.emailValid($scope.enterInfo.contactsEmail)) {
            $scope.notValidEmail = true;
          } else {
            $scope.notValidEmail = false;
          }
        }

        $scope.openProtocolModal = function () {
          $scope.protocolModal.show();
        }

        $scope.closeProtocolModal = function () {
          $scope.protocolModal.hide();
        }

        $scope.openSettingPwdModal = function () {
          systemManageService.checkVerificationCode($scope.enterInfo.captcha).then(function (response) {
            if('200' == response.code){
              $scope.settingPwdModal.show();
            }else{
              $scope.notValidCaptcha = true;
            }
          });
        }

        $scope.closeSettingPwdModal = function () {
          $scope.settingPwdModal.hide();
        }

        $scope.openEnterpriseInfoModal = function () {
          $scope.enterpriseInfoModal.show();
        }

        $scope.closeEnterpriseInfoModal = function () {
          $scope.enterpriseInfoModal.hide();
        }

        $scope.openRegisterEndModal = function () {
          //loading提示框，防止重复提交
          commonUtil.loadingShow($ionicLoading);

          var params = $scope.enterInfo;
          delete params["passwordNewConfirm"];
          delete params["enterpriseAddressTemp"];
          params.paperTicketed = params.paperTicketed == true ? "yes" : "no";
          enterpriseInfoService.addInfo(params).then(function (response) {
            //对应loadingShow，关闭loading
            $ionicLoading.hide();
            //提示框
            var myPopup = commonUtil.popupShow($ionicPopup,"提示", response.msg);

            if(response.code === "200"){
              $scope.registerEndModal.show();
            }

            //自动关闭提示框
            commonUtil.timeout($timeout, myPopup);
          });


        }

        $scope.closeRegisterEndModal = function () {
          $scope.registerEndModal.hide();
        }

        $scope.registerEnd = function () {
          $scope.registerEndModal.hide();
          $scope.enterpriseInfoModal.hide();
          $scope.settingPwdModal.hide();
          $scope.protocolModal.hide();
          $state.go("tab.home", {}, {reload: true});
        }

        $scope.getProvinceAddress = function () {
          getProvinceList($scope, systemManageService);
          $scope.provinceModal.show();
        }

        $scope.getCityAddress = function (parentCode) {
          $scope.parentCode = parentCode;
          getCityList($scope, systemManageService);
          $scope.cityModal.show();
        }

        $scope.hideProvinceModal = function () {
          $scope.provinceModal.hide();
        }

        $scope.hideCityModal = function () {
          $scope.cityModal.hide();
        }

        $scope.selectAddress = function (cityCode) {
          $scope.provinceList = $scope.provinceList2;
          $scope.cityList = $scope.cityList2;
          $scope.enterInfo.provinceId = $scope.parentCode;
          $scope.enterInfo.cityId = cityCode;
          $scope.enterpriseAddressTemp = $filter('provinceFilter')($scope.parentCode,$scope.provinceList) + $filter('cityFilter')(cityCode, $scope.cityList);
          $scope.provinceModal.hide();
          $scope.cityModal.hide();
        }

        $ionicModal.fromTemplateUrl("settingPwd-modal.html", {
          scope: $scope,
          animation: "slide-in-up",
        }).then(function (modal) {
          $scope.settingPwdModal = modal;
        });

        $ionicModal.fromTemplateUrl("enterpriseInfo-modal.html", {
          scope: $scope,
          animation: "slide-in-up",
        }).then(function (modal) {
          $scope.enterpriseInfoModal = modal;
        });

        $ionicModal.fromTemplateUrl("registerEnd-modal.html", {
          scope: $scope,
          animation: "slide-in-up",
        }).then(function (modal) {
          $scope.registerEndModal = modal;
        });

        $ionicModal.fromTemplateUrl("protocol-modal.html", {
          scope: $scope,
          animation: "slide-in-up",
        }).then(function (modal) {
          $scope.protocolModal = modal;
        });

        $ionicModal.fromTemplateUrl('province-modal.html', {
          scope: $scope,
          animation: 'slide-in-left'
        }).then(function (modal) {
          $scope.provinceModal = modal;
        });

        $ionicModal.fromTemplateUrl('city-modal.html', {
          scope: $scope,
          animation: 'slide-in-left'
        }).then(function (modal) {
          $scope.cityModal = modal;
        });

        //拍照功能
        $scope.show = function (event) {
          console.log(event);
          //window._curImgId = ($(event.target).prev('img')[0]).id;
          $ionicPopup.show({
            title: '上传图片',
            scope: $scope,
            buttons: [
              {
                text: '拍照',
                onTap: function () {
                  $scope.takeCameraPicture();
                }
              },
              {
                text: '相册',
                onTap: function () {
                  $scope.pickImg();
                }
              },
              {text: '取消'}
            ]
          });
        };
        var callback = function (r) {
          $ionicLoading.hide();
          var res = angular.fromJson(r.response);
          if (res.code !== "200") {
            var myPopup = commonUtil.popupShow($ionicPopup, "提示", res.msg);
            //自动关闭提示框
            commonUtil.timeout($timeout, myPopup);
          } else {
            var socialCodeCertificate = res.data.imgUrl;
            $scope.displayImg = true;
            $scope.enterInfo.socialCodeCertificate = socialCodeCertificate;
            $scope.imgSrc = downloadUrl + "?socialCodeCertificate=" + socialCodeCertificate;
            $scope.$apply();
          }
        };

        $scope.pickImg = function () {
          imgUploadService.pickImg(callback);
        };

        $scope.takeCameraPicture = function () {
          imgUploadService.takeCameraPicture(callback);
        };

        function getProvinceList($scope, systemManageService) {
          systemManageService.getProvinceAddr().then(function (response) {
            $scope.provinceList2 = response.data;
          });
        }

        function getCityList($scope, systemManageService) {
          systemManageService.getCityAddr($scope.parentCode).then(function (response) {
            $scope.cityList2 = response.data;
          });
        }
      }])
    .filter("provinceFilter", function () {
        return function (input, provinceList) {
          if (typeof(input) != "undefined" && typeof(provinceList) != "undefined") {
            for (var i = 0; i < provinceList.length; i++) {
              if (input == provinceList[i].areaCode) {
                return provinceList[i].areaName;
              }
            }
          }
        }
      }
    )
    .filter("cityFilter", function () {
        return function (input, cityList) {
          if (typeof(input) != "undefined" && typeof(cityList) != "undefined") {
            for (var i = 0; i < cityList.length; i++) {
              if (input == cityList[i].areaCode) {
                return cityList[i].areaName;
              }
            }
          }
        }
      }
    )
    .controller('login.controller', ['$scope', '$state', '$ionicPopup', '$timeout', '$filter', 'systemManageService', function ($scope, $state, $ionicPopup, $timeout, $filter, systemManageService) {
      var loginInfo = angular.fromJson(window.localStorage.getItem('loginInfo'));
      if(null === loginInfo){
        $scope.loginInfo = {
          loginName: '',
          password: '',
          displayPassword: '',
          isSavePassword: false
        };
      }else{
        $scope.loginInfo = {
          loginName: loginInfo.loginName,
          password: '',
          displayPassword: loginInfo.displayPassword,
          isSavePassword: true
        };
      }
      //获取publickey
      systemManageService.getPublicKey().then(function (response) {
        //TODO服务异常处理
        $scope.publicKey = response.split(",")[0];
      });
      $scope.validPassword = function () {
        if (!validUtil.passwordValid($scope.loginInfo.displayPassword)) {
          $scope.notValidPassword = true;
        } else {
          $scope.notValidPassword = false;
        }
      }
      $scope.login = function () {
        if(typeof($scope.publicKey) == "undefined" || $scope.publicKey == null || $scope.publicKey == ""){
          $scope.publicKey = 'cb4b919643a83874a42c72cae0effe220a0146dade1a9e4e599fdaa42d2c9ecbec98fdf79068504a5205235d29e8d70cea50189ddd70e6299f1f045087be912301874088178b17c0c1f5d1cf41c1228dda59f8f785935c9ca6a6acd0327d1252cad3ff2d8fa4eac4f53816de210c9e1d72303c426b8051b2652dbd30b7c7b0c9';
        }
        var loginInfoObject = {
          loginName: $scope.loginInfo.loginName,
          displayPassword: $scope.loginInfo.displayPassword
        }
        if($scope.loginInfo.isSavePassword){
          window.localStorage.setItem('loginInfo', angular.toJson(loginInfoObject));
        }else{
          window.localStorage.removeItem('loginInfo');
        }
        $scope.loginInfo.password = rsa.doRSAEncrypt($scope.publicKey, $scope.loginInfo.displayPassword);
        var params = $scope.loginInfo;
        systemManageService.login(params).then(function (response) {
          if (response.code === 200) {
            $state.go("tab.home", {}, {reload: true});
          } else {
            //提示框
            var myPopup = commonUtil.popupShow($ionicPopup, "提示", response.msg);
            $scope.loginInfo = new Object();
            //自动关闭提示框
            commonUtil.timeout($timeout, myPopup);
          }

        });
      }
      }])
    .controller('forgetPassword', ['$scope', '$ionicModal', '$filter', '$ionicLoading', '$ionicPopup', '$location', '$timeout', 'systemManageService', function ($scope, $ionicModal, $filter, $ionicLoading, $ionicPopup, $location, $timeout, systemManageService) {
      $scope.accountInfo = {
        loginName: '',
        contractPhone: '',
        verificationCode: '',
        requestKey: ''
      };
      $scope.checkStatus = {
        accountInfoStatus: false,
        verification: false
      };
      $scope.redirectLogin = function () {
        $location.path('/login');
      };
      forgetPasswordModal();
      $scope.updatePasswordFunction = {
        changeAccountInfo: function () {
          $scope.checkStatus.accountInfoStatus = false;
        },
        changeVerificationCode: function () {
          $scope.checkStatus.verification = false;
        }
      };
      $scope.checkVerificationCode = function (formObject) {
        if(formObject.$valid){
          systemManageService.checkVerificationCode($scope.accountInfo.verificationCode).then(function (response) {
            if('200' == response.code){
              showForgetPasswordModal();
            }else{
              $scope.checkStatus.verification = true;
            }
          });
        }
      };
      $scope.hideForgetPasswordModal = function () {
        $scope.accountInfo.verificationCode = '';
        $scope.accountInfo.requestKey = '';
        $scope.forgetPasswordModal.hide();
      };
      $scope.updatePassword = function () {
        commonUtil.loadingShow($ionicLoading);
        systemManageService.updatePassword($scope.accountInfo.requestKey, $scope.passwordInfo.newPassword).then(function (response) {
          $ionicLoading.hide();
          var popup = commonUtil.popupShow($ionicPopup, "提示", '200' === response.code ? '保存成功' : '保存失败');
          popup.then(function () {
            if ('200' === response.code) {
              $scope.forgetPasswordModal.hide();
              $location.path('/login');
            }
          });
          $timeout(function () {
            popup.close();
            if ('200' === response.code) {
              $scope.forgetPasswordModal.hide();
              $location.path('/login');
            }
          }, 2000);
        });
      };
      function showForgetPasswordModal() {
        $scope.passwordInfo = {
          newPassword: '',
          confirmPassword: ''
        };
        $scope.forgetPasswordModal.show();
      }
      function forgetPasswordModal() {
        $ionicModal.fromTemplateUrl("forgetPassword-modal.html", {
          scope: $scope,
          animation: "slide-in-up"
        }).then(function (modal) {
          $scope.forgetPasswordModal = modal;
        });
      }
    }])
    .directive('timerButton', ['$timeout', '$interval', '$filter', '$ionicLoading', 'systemManageService', function ($timeout, $interval, $filter, $ionicLoading, systemManageService) {
      return {
        restrict: 'AE',
        $scope: {
          showTimer: '',
          timeout: ''
        },
        link: function ($scope) {
          $scope.disabledButton = false;
          $scope.timeout = 60000;
          $scope.timerCount = $scope.timeout / 1000;
          $scope.text = "获取验证码";
          $scope.sendVerificationCode = function (formObject) {
            if(formObject.loginName.$valid && formObject.contractPhone.$valid){
              commonUtil.loadingShow($ionicLoading);
              systemManageService.checkAccountInfo($scope.accountInfo).then(function (response) {
                $ionicLoading.hide();
                if('200' === response.code){
                  $scope.accountInfo.requestKey = response.data;
                  $scope.showTimer = true;
                  $scope.disabledButton = true;
                  $scope.text = "秒后重新获取";
                  var counter = $interval(function () {
                    $scope.timerCount = $scope.timerCount - 1;
                  }, 1000);
                  $timeout(function () {
                    $scope.text = "获取验证码";
                    $scope.disabledButton = false;
                    $interval.cancel(counter);
                    $scope.showTimer = false;
                    $scope.timerCount = $scope.timeout / 1000;
                  }, $scope.timeout);
                  systemManageService.sendVerificationCode($scope.accountInfo.contractPhone);
                }else{
                  $scope.checkStatus.accountStatus = true;
                }
              });
            }
          }
        },
        template: '<button on-tap="sendVerificationCode(accountInfoForm);" class="button button-block pt-public-btn1 yzm-font" ng-disabled="disabledButton"><span ng-if="showTimer">{{timerCount}}</span>{{text}}</button>'
      };
    }]);
});
