/**
 * Created by user on 2016/6/24.
 */

require.config({

    paths: {
      /*** 工具包*/
      "app" : "app",
      "angular": "../lib/ionic/js/ionic.bundle",
      "text" : "../lib/require/text",
      "json" : "../lib/require/json",
      "commonUtil" : "utils/commonUtil",
      "commonModule" : "utils/commonModule",
      "validUtil" : "utils/validUtil",
      "imgUpload" : "utils/imgUpload",
      "rsa" : "utils/rsa/rsa",
      "jsbn" : "utils/rsa/jsbn",
      "prng4" : "utils/rsa/prng4",
      "rng" : "utils/rsa/rng",
      /*** 工具包 end*/

      /*** 权限和网络请求配置*/
      "role_factory" : "../config/config.js/role_factory",
      "role_config" : "../config/config.json/role_config.json",

      "ajax_factory" : "../config/config.js/ajax_factory",
      "ajax_config" : "../config/config.json/ajax_config.json",
      /*** 权限和网络请求配置 end*/

      /*** 业务配置*/

      /** controller  */
      "homeController" : "controllers/homeController",//主页
      "systemManageController" : "controllers/business/systemManageController",
      "invoiceManageController" : "controllers/business/invoiceManageController",
      "customerManageController" : "controllers/business/customerManageController",
      "commodityManageController" : "controllers/business/commodityManageController",
      "invoiceSettingController"  :  "controllers/business/invoiceSettingController",
      "personCenterController" : "controllers/business/personCenterController",
      "enterpriseInfoController" : "controllers/business/enterpriseInfoController",
      "invoiceClerkManageController" : "controllers/business/invoiceClerkManageController",
      "invoiceInsertController" : "controllers/business/invoiceInsertController",
      "redInvoiceInsertController" : "controllers/business/redInvoiceInsert",

      /** controller end */

      /** services  */
      "homeServices" : "services/homeServices",//主页
      "systemManageService" : "services/business/systemManageService",
      "invoiceManageService" : "services/business/invoiceManageService",
      "customerManageService" : "services/business/customerManageService",
      "commodityManageService" : "services/business/commodityManageService",
      "invoiceSettingService"  :  "services/business/invoiceSettingService",
      "personCenterService" : "services/business/personCenterService",
      "enterpriseInfoService" : "services/business/enterpriseInfoService",
      "invoiceClerkManageService" : "services/business/invoiceClerkManageService",

      /** services  end*/

      /** modules  */
      'systemManageModule' : "modules/systemManageModule",
      'invoiceManageModule' : "modules/invoiceManageModule",
      'customerManageModule' : "modules/customerManageModule",
      'commodityManageModule' : "modules/commodityManageModule",
      'invoiceSettingModule'  :  "modules/invoiceSettingModule",
      'personCenterModule' : "modules/personCenterModule",
      'enterpriseInfoModule' : "modules/enterpriseInfoModule",
      'invoiceClerkManageModule' : "modules/invoiceClerkManageModule"

      /** modules  end*/
      /*** 业务配置 end*/
    },
    shim: {
      "angular": {
          exports: "angular"
        },
      /*** 加载项目依赖模块 */
      "app" : [
        'imgUpload',

        'homeController',
        'systemManageController',
        'invoiceManageController',
        'customerManageController',
        'commodityManageController',
        'invoiceSettingController',
        'personCenterController',
        'enterpriseInfoController',
        'invoiceClerkManageController',
        'invoiceInsertController',
        'redInvoiceInsertController',

        'homeServices',
        'systemManageService',
        'invoiceManageService',
        'customerManageService',
        'commodityManageService',
        'invoiceSettingService',
        'personCenterService',
        'enterpriseInfoService',
        'invoiceClerkManageService',

        'systemManageModule',
        'invoiceManageModule',
        'customerManageModule',
        'commodityManageModule',
        'invoiceSettingModule',
        'personCenterModule',
        'enterpriseInfoModule',
        'invoiceClerkManageModule'

      ]

      /*** 加载项目依赖模块 end*/
    }

});

//启动项目
require(['angular','app'],function (angular) {
    //var module;
    //var url = document.URL;
    //url = url.substr(0,url.lastIndexOf("."));
    //module = url.substr(url.lastIndexOf("/")+1);
    //
    //module = module == "system" ? "systemManage.module":"index";
    angular.bootstrap(document,['index']);

});
//启动项目 end

