/**
 * Created by user on 2016/6/28.
 */
define(['angular', 'ajax_factory'], function (angular, ajax_factory) {
    angular.module('commodityManage.service', [])
        .factory('commodityManageService', function ($http) {
            return {
                getServices: function () {
                    return 'Get_CommodityManageService'
                },
                getCommodityList: function (pageIndex, pageSize, codeOrName) {
                    var parameter = {
                        pageIndex : pageIndex,
                        pageSize : pageSize,
                        codeOrName : codeOrName
                    };
                    return $http(ajax_factory.get('getProductList', parameter)).then(function (response) {
                        return response.data;
                    }, function (err) {
                        return err;
                    })
                },
                getCommodity: function (enterpriseProductId) {
                    var parameter = {
                        enterpriseProductId : enterpriseProductId
                    };
                    return $http(ajax_factory.get('getProduct', parameter)).then(function (response) {
                        return response.data;
                    }, function (err) {
                        return err;
                    })
                },
                deleteCommodity: function (enterpriseProductId) {
                    var params = {
                        enterpriseProductId : enterpriseProductId
                    };
                    return $http(ajax_factory.get('deleteProduct', params)).then(function (response) {
                        return response.data;
                    }, function (err) {
                        return err;
                    })
                },
                getTaxTypeList : function (pageIndex, pageSize, searchParameter) {
                    var parameter = {
                        pageIndex : pageIndex,
                        pageSize : pageSize,
                        keyWord : searchParameter
                    };
                    return $http(ajax_factory.get('getTaxCategoryList', parameter)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                getEnterpriseTaxRateList : function () {
                    return $http(ajax_factory.get('getEnterpriseTaxRateList')).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                validProductCodeForInsert : function (enterpriseCommodityCode) {
                    var parameter = {
                        enterpriseCommodityCode : enterpriseCommodityCode
                    };
                    return $http(ajax_factory.get('validProductCodeForInsert', parameter)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                validProductCodeForUpdate : function (enterpriseCommodityCode, enterpriseProductId) {
                    var parameter = {
                        enterpriseCommodityCode : enterpriseCommodityCode,
                        enterpriseProductId : enterpriseProductId
                    };
                    return $http(ajax_factory.get('validProductCodeForUpdate', parameter)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                saveCommodity: function (product) {
                    return $http(ajax_factory.post('saveProduct', product)).then(function (response) {
                        return response.data;
                    }, function (err) {
                        return err;
                    })
                },
                updateCommodity: function (product) {
                    return $http(ajax_factory.post('updateProduct', product)).then(function (response) {
                        return response.data;
                    }, function (err) {
                        return err;
                    })
                }
            };
        });
});
