/**
 * Created by user on 2016/6/28.
 */

define(['angular','ajax_factory','commonUtil'], function (angular,ajax_factory,commonUtil) {

  angular.module('customerManage.service',[])

    .factory('customerManageService',function($http){

      return {
        getServices : function () {
          return 'Get_CustomerManageService'
        },
        getCustomerList : function(page, rows, customerNameOrCode){
          return $http(ajax_factory.get('getCustomerList',{"pageIndex":page,"pageSize":rows,"customerNameOrCode":customerNameOrCode})).then(function (response) {
            return response.data;
          },function (err) {
            return err;
          })
        },
          //详情
        getCustomerById : function(id){
          return $http(ajax_factory.get('getCustomerById',{"customerId":id})).then(function (response) {
            return response.data;
          },function (err) {
            return err;
          })
        },
       //修改
        modifyCustomer : function(params){
          return $http(ajax_factory.post('modifyCustomer',params)).then(function (response) {
            return response.data;
          },function (err) {
            return err;
          })
        },
        //删除
        deleteCustomerById : function(id){
          return $http(ajax_factory.post('deleteCustomerById',commonUtil.param({'customerId':id}), true)).then(function (response) {
            return response.data;
          },function (err) {
            return err;
          })
        },
         //新增
        insertCustomer : function(params){
          return $http(ajax_factory.post('insertCustomer', params)).then(function (response) {
            return response.data;
          },function (err) {
            return err;
          })
        }
      };

    });



});
