/**
 * Created by user on 2016/6/28.
 */

define(['angular', 'ajax_factory'], function (angular, ajax_factory) {
    angular.module('invoiceManage.service', [])
        .factory('invoiceManageService', function ($http) {
            return {
                getServices: function () {
                    return 'Get_InvoiceManageService'
                },
                getInvoiceList : function(pageIndex, pageSize, kpzt){
                    var parameter = {
                        pageIndex : pageIndex,
                        pageSize : pageSize,
                        kpzt : kpzt
                    };
                    return $http(ajax_factory.get('getInvoiceList', parameter)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                getInvoiceDetail : function(fpqqlsh){
                    var parameter = {
                        fpqqlsh: fpqqlsh
                    };
                    return $http(ajax_factory.get('getInvoiceDetail', parameter)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                removeInvoice : function (fpqqlsh) {
                    return $http(ajax_factory.get('removeInvoice', {'fpqqlsh': fpqqlsh})).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                billingInvoice : function (fpqqlsh) {
                    return $http(ajax_factory.get('billingInvoice', {'fpqqlsh': fpqqlsh})).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                resendInvoice : function (message) {
                    return $http(ajax_factory.get('resendInvoice', message)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                getOftenCustomerList : function () {
                    return $http(ajax_factory.get('getOftenCustomerList')).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                getCustomerList : function (pageIndex, pageSize, searchParameter) {
                    var parameter = {
                        pageIndex : pageIndex,
                        pageSize : pageSize,
                        customerNameOrCode : searchParameter
                    };
                    return $http(ajax_factory.get('getCustomerList', parameter)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                validateInvoice : function (fpDmFpHm) {
                    var parameter = {
                        fpDmFpHm : fpDmFpHm
                    };
                    return $http(ajax_factory.get('validateInvoice', parameter)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                getRedInvoiceDeatil : function (fpDmFpHm) {
                    var parameter = {
                        fpDmFpHm : fpDmFpHm
                    };
                    return $http(ajax_factory.get('getRedInvoiceDeatil', parameter)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                saveRedInvoice : function (fpDmFpHm, redReason) {
                    var parameter = {
                        fpDmFpHm : fpDmFpHm,
                        redReason : redReason
                    };
                    return $http(ajax_factory.get('saveRedInvoice', parameter)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                getOftenProductList : function () {
                    return $http(ajax_factory.get('getOftenProductList')).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                getEnterpriseTaxRateList : function () {
                    return $http(ajax_factory.get('getEnterpriseTaxRateList')).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                getProductList : function (pageIndex, pageSize, searchParameter) {
                    var parameter = {
                        pageIndex : pageIndex,
                        pageSize : pageSize,
                        codeOrName : searchParameter
                    };
                    return $http(ajax_factory.get('getProductList', parameter)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                getOftenTaxTypeList : function (pageIndex, pageSize) {
                    var parameter = {
                        pageIndex : pageIndex,
                        pageSize : pageSize,
                        keyWord : ''
                    };
                    return $http(ajax_factory.get('getTaxCategoryList', parameter)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                getTaxTypeList : function (pageIndex, pageSize, searchParameter) {
                    var parameter = {
                        pageIndex : pageIndex,
                        pageSize : pageSize,
                        keyWord : searchParameter
                    };
                    return $http(ajax_factory.get('getTaxCategoryList', parameter)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                saveInvoice : function (invoice) {
                    return $http(ajax_factory.post('saveInvoice', invoice)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                saveAndMakeInvoice : function (invoice) {
                    return $http(ajax_factory.post('saveAndMakeInvoice', invoice)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                },
                updateInvoice : function (invoice) {
                    return $http(ajax_factory.post('updateInvoice', invoice)).then(function (response) {
                        return response.data;
                    },function (err) {
                        return err;
                    });
                }
            };
        });
});
