/**
 * Created by user on 2016/6/28.
 */

define(['angular', 'ajax_factory', 'commonUtil'], function (angular, ajax_factory, commonUtil) {

  angular.module('systemManage.service', [])
    .factory('systemManageService', function ($http) {
      return {
        getServices: function () {
          return 'Get_SystemManageService'
        },
        getProvinceAddr: function () {
          return $http(ajax_factory.get('getProvinceAddr')).then(function (response) {
            return response.data;
          }, function (err) {
            return err;
          })
        },
        getCityAddr: function (parentCode) {
          return $http(ajax_factory.get('getCityAddr', {"parentCode": parentCode})).then(function (response) {
            return response.data;
          }, function (err) {
            return err;
          })
        },
        getLoginInfo: function () {
          return $http(ajax_factory.get('getLoginInfo')).then(function (response) {
            return response.data;
          }, function (err) {
            return err;
          });
        },
        checkLogin: function () {
          return $http(ajax_factory.post('checkLogin')).then(function (response) {
            return response.data;
          }, function (err) {
            return err;
          });
        },
        getPublicKey: function () {
          return $http(ajax_factory.post('getPublicKey')).then(function (response) {
            return response.data;
          }, function (err) {
            return err;
          });
        },
        login: function (params) {
          return $http(ajax_factory.post('login', commonUtil.param(params), true)).then(function (response) {
            return response.data;
          }, function (err) {
            return err;
          });
        },
        checkAccountInfo: function (accountInfo) {
          return $http(ajax_factory.get('checkAccountInfo', accountInfo)).then(function (response) {
            return response.data;
          }, function (err) {
            return err;
          });
        },
        sendVerificationCode: function (mobile) {
          var parameter = {
            mobile : mobile
          };
          return $http(ajax_factory.get('sendVerificationCode', parameter)).then(function (response) {
            return response.data;
          }, function (err) {
            return err;
          });
        },
        checkVerificationCode: function (verificationCode) {
          var parameter = {
            code : verificationCode
          };
          return $http(ajax_factory.get('checkVerificationCode', parameter)).then(function (response) {
            return response.data;
          }, function (err) {
            return err;
          });
        },
        updatePassword: function (key, newPassword) {
          var parameter = {
            key: key,
            loginPassword: newPassword
          };
          return $http(ajax_factory.get('updatePassword', parameter)).then(function (response) {
            return response.data;
          }, function (err) {
            return err;
          });
        },
        logout: function () {
          return $http(ajax_factory.get('logout')).then(function (response) {
            return response.data;
          }, function (err) {
            return err;
          });
        },
      };
    });


});
