
define(['angular'], function(angular){

  return {
    popupShow :  function ($ionicPopup,title, msg){
      return $ionicPopup.show({
        title: title,
        template: '<p class="pop-center">'+msg+'</p>',
        buttons: [
          {text: "确定"}
        ]
      });
    },
    showPrompt : function ($ionicLoading, msg) {
      return $ionicLoading.show({
        template: msg
      });
    },
    loadingShow : function ($ionicLoading) {
      $ionicLoading.show({
        template: 'Loading...',
        delay: 0
      });
    },
    timeout : function ($timeout, pop) {
      $timeout(function() {
        pop.close(); // 2秒后关闭弹窗
      }, 2000);
    },

    //transformRequest : function (data) {
    //  return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
    //}

    param : function(obj) {
        var query = '', name, value, fullSubName, subName, subValue, innerObj, i;

        for (name in obj) {
          value = obj[name];

          if (value instanceof Array) {
            for (i = 0; i < value.length; ++i) {
              subValue = value[i];
              fullSubName = name + '[' + i + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          }
          else if (value instanceof Object) {
            for (subName in value) {
              subValue = value[subName];
              fullSubName = name + '[' + subName + ']';
              innerObj = {};
              innerObj[fullSubName] = subValue;
              query += param(innerObj) + '&';
            }
          }
          else if (value !== undefined && value !== null)
            query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
        }

        return query.length ? query.substr(0, query.length - 1) : query;
      }
  }

});
