/**
 * Created by Administrator on 2016/7/5.
 */

define(['angular','ajax_factory', 'commonUtil'], function (angular,ajax_factory,commonUtil) {

  angular.module('imgUpload.service',[])
    .service('imgUploadService',function ($ionicLoading) {

      var fileURL = '';
      var baseURL = '';
      var uploadURL = ajax_factory.getPath("upload");


      var upload = function(callback){

        var uri = encodeURI(uploadURL);
        function fail(error) {
          var myPopup =  commonUtil.popupShow($ionicPopup, "提示", '上传失败');
          commonUtil.timeout($timeout, myPopup);
          // alert("An error has occurred: Code = " + JSON.stringify(error));
          $ionicLoading.hide();
        }

        var options = new FileUploadOptions();
        options.fileKey="uploader";
        options.fileName=fileURL.substr(fileURL.lastIndexOf('/')+1);
        options.mimeType="multipart/form-data";

        var ft = new FileTransfer();
        $ionicLoading.show({
          template: '上传中...'
        });
        ft.onprogress = function(progressEvent) {
          if (progressEvent.lengthComputable) {
            loadingStatus.setPercentage(progressEvent.loaded / progressEvent.total);
          } else {
            loadingStatus.increment();
          }
        };
        ft.upload(fileURL, uri, callback, fail, options);
      }

     this.takeCameraPicture = function (callback) {

        navigator.camera.getPicture(onSuccess, onFail, {
          quality: 30,
          destinationType: Camera.DestinationType.FILE_URI,
          sourceType: Camera.PictureSourceType.CAMERA,
          encodingType: Camera.EncodingType.JPEG,
          //targetWidth: 800,
          //targetHeight: 100,
          saveToPhotoAlbum: true
        });

        function onSuccess(imageURI) {
          fileURL = imageURI;
          upload(callback);
        }

        function onFail(message) {
          // alert("上传失败!");
        }

      };

      this.pickImg = function (callback) {
        window.imagePicker.getPictures(
          function (results) {
            for (var i = 0; i < results.length; i++) {
              console.log('Image URI: ' + results[i]);
              fileURL = results[i];
            }
            if(results.length==0)return;
            upload(callback);
          }, function (error) {
            console.log('Error: ' + error);

          }, {
            maximumImagesCount: 1,
            //width: 800,
            quality: 30
          }
        );
      }

      this.getBaseURL = function(){
        return baseURL;
      }

      this.getUserInfo = function(){
        return window.userInfo;
      }

    })
})
